/**************************************************************************/
/*									  */
/* Copyright (c) 2000-2005 by Alexandr V. Shutko, Khabarovsk, Russia	  */
/* All rights reserved.							  */
/*									  */
/* Redistribution and use in source and binary forms, with or without	  */
/* modification, are permitted provided that the following conditions	  */
/* are met:								  */
/* 1. Redistributions of source code must retain the above copyright	  */
/*    notice, this list of conditions and the following disclaimer.	  */
/* 2. Redistributions in binary form must reproduce the above copyright	  */
/*    notice, this list of conditions and the following disclaimer in 	  */
/*    the documentation and/or other materials provided with the 	  */
/*    distribution.							  */
/*									  */
/* THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 	  */
/* PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS  */
/* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 	  */
/* OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT   */
/* OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 	  */
/* BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,  */
/* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE   */
/* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 	  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.			  */
/*									  */
/* This unit implements defragmentator-processor 			  */
/*                                                                        */
/* $Id: fprocess.cpp,v 1.6 2005/01/24 10:12:48 regressor Exp $    	  */
/**************************************************************************/

#include "includes.h"

/**************************************************************************/
/* main defragmentator-process loop 	 				  */
/**************************************************************************/
void process_defrag()
{
   struct defrag_pack dpack;
   usersdb_connect();			/* connect to users database */
  
   for(;;)
   {
      defrag_receive_pipe(dpack);
     
      switch(dpack.mtype)
      {
         case MESS_DEFRAG:   DEBUG(50, ("Received MESS_DEFRAG (for %lu [%d])...\n", dpack.uin_num, dpack.seq));
                             db_defrag_check(dpack.uin_num, dpack.seq); break;
         case MESS_FRGCHECK: db_defrag_check(); break;
          
         default: LOG_SYS(0, ("Unknown message from defragment pipe...\n"));
                  break;  
      }
   }
   return;
}

